package seminar7;

public class Employee {
    final private String name;
    final private SalaryStrategy salaryStrategy;
    final private PayoutStrategy payoutStrategy;

    public Employee(String name, SalaryStrategy salaryStrategy, PayoutStrategy payoutStrategy) {
        this.name = name;
        this.salaryStrategy = salaryStrategy;
        this.payoutStrategy = payoutStrategy;
    }
    
    double salary() {
        return salaryStrategy.salary();
    }
    
    String payout() {
        return payoutStrategy.payout();
    }
    
    @Override
    public String toString() {
        String s = name + " " + salaryStrategy.typeString() + " " 
                + salary() + " paid by: " + payout();
        return s;
    }
    
}
